#ifndef PLAYLISTITEM_H
#define PLAYLISTITEM_H

#include <QString>
#include <QMap>
#include <QDomNode>

class PlaylistItem
{
public:
    enum Type {
        TypeUndefined = -1,
        TypeRemote = 0,
        TypeVideo,
        TypeImage,
        TypePdf,
        TypeWebpage,
        TypeDocument,
        TypeDir,
        TypeNotSupported
    };

    PlaylistItem(QString uri, PlaylistItem::Type type, int time, bool href = false);
    bool isEmpty() const { return m_uri.isEmpty(); };

    PlaylistItem::Type type() const { return m_type; };
    void setTime(unsigned int time) { m_time = time; };
    QString uri() const { return m_uri; };
    void setUri(QString &uri) { m_uri = uri; };
    int time() const { return m_time; };
    bool href() const { return m_href; };

    static PlaylistItem fromXmlNode(QDomNode *node);
    static QString typeToStr(PlaylistItem::Type type);

private:
    QString m_uri;
    PlaylistItem::Type m_type;
    int m_time;
    bool m_href;

    static QMap<PlaylistItem::Type, QString> initStrings();
    static QMap<PlaylistItem::Type, QString> typeToStrMap;
};

#endif
