#ifndef RESTRICTEDWEBPAGE_H
#define RESTRICTEDWEBPAGE_H

#include <QUrl>
#include <QWebPage>
#include <QRegExp>
#include <QNetworkRequest>

#include "settings.h"

class RestrictedWebPage : public QWebPage
{
    Q_OBJECT

public:
    RestrictedWebPage(QWidget *parent = 0);
    ~RestrictedWebPage();

protected:
    QString userAgentForUrl(const QUrl &url) const;

private:
    bool acceptNavigationRequest(QWebFrame *frame, const QNetworkRequest &request, NavigationType type);

    Settings *settings;
    QMap<QString, QString> *downloads; /* fixme */

    QList<QRegExp> regexList;
    void setupRegexList();
    bool urlIsAllowed(QUrl &);

private slots:
    void onDownloadRequested(const QNetworkRequest &request);
    void onUnsupportedContent(QNetworkReply *reply);
    void onDownloadDone();

signals:
    void urlDenied(QString &);
    void downloadStarted();
    void downloadDone(QString &, QString &);
};

#endif
