#ifndef RESTRICTEDWEBVIEW_H
#define RESTRICTEDWEBVIEW_H

#include <QWebView>
#include <QNetworkReply>
#include <QAuthenticator>
#include <QEvent>

class RestrictedWebView : public QWebView
{
    Q_OBJECT

public:
    RestrictedWebView(QUrl url, QWidget *parent = 0);
    void home();

protected:
    bool eventFilter(QObject *object, QEvent *event);

private slots:
    void onUrlDenied(QString);
    void onAuthRequired(QNetworkReply *, QAuthenticator *);

signals:
    void mouseMoved();
    void urlDenied(QString);
};

#endif
