#ifndef VIEWER_H
#define VIEWER_H

#include <QTimer>
#include <QStackedWidget>

#include "runnable.h"
#include "settings.h"

class PlaylistEventFilter : public QObject
{
protected:
    bool eventFilter(QObject *obj, QEvent *event);
};


class BrowserEventFilter : public QObject
{
protected:
    bool eventFilter(QObject *obj, QEvent *event);
};


class Viewer : public QStackedWidget
{
    Q_OBJECT

public:
    Viewer();

    void resetTimer();
    void emitMouseEvent() { emit(mouseEvent()); };

public slots:
    void next(QWidget *widget);

protected:
    void closeEvent(QEvent *event);

private:
    Settings *settings;
    QTimer m_timer;

    QWidget *prevWidget;

    PlaylistEventFilter *m_playlistEventFilter;
    BrowserEventFilter *m_browserEventFilter;

    void loadWindowSettings();
    void saveWindowSettings();
    void setShortcuts();
    void setTimer();

private slots:
    void bye();
    void onWidgetTimeout();
    void onTimerTimeout();
    void stop();

signals:
    void end();
    void mouseEvent();
};

#endif
