#ifndef WEBPAGE_H
#define WEBPAGE_H

#include <QTimer>
#include <QWebView>
#include <QNetworkCookieJar>
#include <QUrl>
#include <QEvent>

#include "runnable.h"
#include "playlistitem.h"

class SqliteCookieJar : public QNetworkCookieJar
{
    Q_OBJECT

public:
    SqliteCookieJar(QObject *parent = 0);

private:
    QList<QNetworkCookie> m_cookies;
};

class Webpage : public QWebView, public Runnable
{
    Q_OBJECT
    Q_INTERFACES(Runnable)

public:
    Webpage(PlaylistItem *item, QWidget *parent);
    void run();
    void stop();

protected:
    bool eventFilter(QObject *obj, QEvent *event);

private:
    int m_time;
    QUrl m_uri;
    QTimer m_timer;
    SqliteCookieJar *m_jar;

private slots:
    void onTimeout();
    void onLoadFinished(bool ok);

signals:
    void end();
};

class PostSession : public Webpage
{
    Q_OBJECT
};

#endif
