#include <QDBusConnection>
#include <QDBusMessage>
#include <QVariant>

#include <QDebug>

#include <unistd.h>

#include "settings.h"
#include "utils.h"

QString Utils::getIconTheme()
{
    QDBusConnection bus = QDBusConnection::sessionBus();
    QDBusMessage message = QDBusMessage::createMethodCall(
                                QString("org.xfce.Xfconf"),
                                QString("/org/xfce/Xfconf"),
                                QString(),
                                QString("GetProperty"));
    message << "xsettings" << "/Net/IconThemeName";

    /* FIXME: the return value is always empty */
    QDBusMessage ret = bus.call(message);
    if (ret.type() == QDBusMessage::ReplyMessage)
    {
        return ret.arguments().at(0).toString();
    }

    return QString("elementary-xfce");
}

bool Utils::validateAdminPassword(QString given)
{
    Settings *settings = Settings::load();
    QString password = settings->get("main/admin_passwd").toString();

    if (password.isEmpty())
        return true;

    const char *str = given.toLocal8Bit().data();
    QString crypted = QString(crypt(str, str));

    if (crypted == password)
        return true;

    return false;
}
